import { Service } from "@crazyfactory/tinka";
import { Auth } from "./nodes/Auth";
import { Availability } from "./nodes/Availability";
import { Contact } from "./nodes/Contact";
import { ContactUs } from "./nodes/ContactUs";
import { Education } from "./nodes/Education";
import { Experience } from "./nodes/Experience";
import { Hobbies } from "./nodes/Hobbies";
import { Hr } from "./nodes/Hr";
import { Interests } from "./nodes/Interests";
import { Job } from "./nodes/Job";
import { Language } from "./nodes/Language";
import { OrgAuth } from "./nodes/OrgAuth";
import { PointOfContact } from "./nodes/PointOfContact";
import { Profile } from "./nodes/Profile";
import { Publications } from "./nodes/Publications";
import { References } from "./nodes/References";
import { Skills } from "./nodes/Skills";
import { SocialLogin } from "./nodes/SocialLogin";
import { Specialisations } from "./nodes/Specialisations";
import { Survey } from "./nodes/Survey";
import { TalentSurvey } from "./nodes/TalentSurvey";
import { UserNotification } from "./nodes/UserNotification";
import { Users } from "./nodes/Users";
import { WorkExperience } from "./nodes/WorkExperience";
export interface ISimpleResponse {
    success: boolean;
    message: string;
}
export interface IUserInformation {
    _id: string;
    user: string;
}
export declare class Sdk extends Service {
    private static instances;
    static getInstance(baseUrl: string): Sdk;
    private static getClient;
    readonly users: Users;
    readonly hr: Hr;
    readonly auth: Auth;
    readonly interests: Interests;
    readonly workExperience: WorkExperience;
    readonly specialisations: Specialisations;
    readonly availability: Availability;
    readonly profile: Profile;
    readonly survey: Survey;
    readonly references: References;
    readonly contact: Contact;
    readonly publications: Publications;
    readonly skills: Skills;
    readonly languages: Language;
    readonly experiences: Experience;
    readonly education: Education;
    readonly hobbies: Hobbies;
    readonly poc: PointOfContact;
    readonly job: Job;
    readonly authOrg: OrgAuth;
    readonly talentSurvey: TalentSurvey;
    readonly contactUs: ContactUs;
    readonly socialLogin: SocialLogin;
    readonly notification: UserNotification;
}
