var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Client, Service } from "@crazyfactory/tinka";
import { ContentTypeMiddleware } from "./middlewares/ContentTypeMiddleware";
import { WrapMiddleware } from "./middlewares/WrapMiddleware";
import { Auth } from "./nodes/Auth";
import { Availability } from "./nodes/Availability";
import { Contact } from "./nodes/Contact";
import { ContactUs } from "./nodes/ContactUs";
import { Education } from "./nodes/Education";
import { Experience } from "./nodes/Experience";
import { Hobbies } from "./nodes/Hobbies";
import { Hr } from "./nodes/Hr";
import { Interests } from "./nodes/Interests";
import { Job } from "./nodes/Job";
import { Language } from "./nodes/Language";
import { OrgAuth } from "./nodes/OrgAuth";
import { PointOfContact } from "./nodes/PointOfContact";
import { Profile } from "./nodes/Profile";
import { Publications } from "./nodes/Publications";
import { References } from "./nodes/References";
import { Skills } from "./nodes/Skills";
import { SocialLogin } from "./nodes/SocialLogin";
import { Specialisations } from "./nodes/Specialisations";
import { Survey } from "./nodes/Survey";
import { TalentSurvey } from "./nodes/TalentSurvey";
import { UserNotification } from "./nodes/UserNotification";
import { Users } from "./nodes/Users";
import { WorkExperience } from "./nodes/WorkExperience";
var Sdk = /** @class */ (function (_super) {
    __extends(Sdk, _super);
    function Sdk() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Sdk.getInstance = function (baseUrl) {
        if (!Sdk.instances[baseUrl]) {
            Sdk.instances[baseUrl] = new Sdk(Sdk.getClient(baseUrl));
        }
        return Sdk.instances[baseUrl];
    };
    Sdk.getClient = function (baseUrl) {
        var client = new Client({ baseUrl: baseUrl });
        client.addMiddleware(new WrapMiddleware());
        client.addMiddleware(new ContentTypeMiddleware());
        return client;
    };
    Object.defineProperty(Sdk.prototype, "users", {
        get: function () {
            return new Users(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "hr", {
        get: function () {
            return new Hr(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "auth", {
        get: function () {
            return new Auth(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "interests", {
        get: function () {
            return new Interests(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "workExperience", {
        get: function () {
            return new WorkExperience(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "specialisations", {
        get: function () {
            return new Specialisations(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "availability", {
        get: function () {
            return new Availability(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "profile", {
        get: function () {
            return new Profile(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "survey", {
        get: function () {
            return new Survey(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "references", {
        get: function () {
            return new References(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "contact", {
        get: function () {
            return new Contact(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "publications", {
        get: function () {
            return new Publications(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "skills", {
        get: function () {
            return new Skills(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "languages", {
        get: function () {
            return new Language(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "experiences", {
        get: function () {
            return new Experience(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "education", {
        get: function () {
            return new Education(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "hobbies", {
        get: function () {
            return new Hobbies(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "poc", {
        get: function () {
            return new PointOfContact(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "job", {
        get: function () {
            return new Job(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "authOrg", {
        get: function () {
            return new OrgAuth(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "talentSurvey", {
        get: function () {
            return new TalentSurvey(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "contactUs", {
        get: function () {
            return new ContactUs(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "socialLogin", {
        get: function () {
            return new SocialLogin(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sdk.prototype, "notification", {
        get: function () {
            return new UserNotification(this.client);
        },
        enumerable: true,
        configurable: true
    });
    Sdk.instances = {};
    return Sdk;
}(Service));
export { Sdk };
