import { Service } from "@crazyfactory/tinka";
import { ISimpleResponse } from "../Sdk";
declare type TAvailability = "AVAILABLE" | "OPEN_TO_OPPORTUNITIES" | "NOT_OPEN";
declare type TNoticePeriod = "IMMEDIATE" | "15 DAYS" | "30 DAYS" | "45 DAYS" | "60 DAYS" | "90 DAYS" | "NOT SURE";
interface ICreateAvailabilityRequest {
    availability: TAvailability;
    notice_period: TNoticePeriod;
    from: number;
    to: number;
}
interface IAvailability {
    availability: TAvailability;
    notice_period: TNoticePeriod;
    expectations: {
        from: number;
        to: number;
    };
    user?: string;
}
export declare class Availability extends Service {
    create(availability: ICreateAvailabilityRequest): Promise<ISimpleResponse>;
    update(availability: ICreateAvailabilityRequest): Promise<ISimpleResponse>;
    getAvailability(): Promise<IAvailability>;
}
export {};
