import { Service } from "@crazyfactory/tinka";
import { ISimpleResponse } from "../Sdk";
interface IPosition {
    title: string;
    code: string;
    contract_type: string;
    job_location: string;
    closing_date: string;
    recruitment_type: string;
    estimated_salary: number;
    estimated_salary_currency: string;
    specification: ISpecification;
}
interface ISpecification {
    expertise: string;
    focus: string;
    sdg: string;
}
interface IBasicRequirement {
    experience: string;
    min_education: string;
    languages: string[];
    techSkills: string[];
}
interface IRoleRequirement {
    nationality: string;
    gender: string;
    additional_information: string;
}
interface IJob {
    type: string;
    position: IPosition;
    responsibilities: string;
    qualifications: string;
    basic_requirements: IBasicRequirement;
    role_requirements: IRoleRequirement;
}
interface IDbJob extends IJob {
    _id: string;
}
export declare class Job extends Service {
    list(): Promise<IDbJob[]>;
    create(job: IJob): Promise<ISimpleResponse>;
    update(job: IJob, jobId: string): Promise<ISimpleResponse>;
}
export {};
