import { Service } from "@crazyfactory/tinka";
import { ISimpleResponse } from "../Sdk";
import { IBasicAuthResponse } from "./Auth";
interface ICreateUserOptions {
    username: string;
    first_name: string;
    middle_name?: string;
    last_name: string;
    email: string;
    password: string;
}
interface IResetPasswordRequest {
    password: string;
    reset_token: string;
}
interface IChangePasswordRequest {
    old_password: string;
    new_password: string;
}
interface IEditNameRequest {
    first_name: string;
    last_name: string;
    middle_name?: string;
}
export declare class Users extends Service {
    create(user: ICreateUserOptions): Promise<IBasicAuthResponse>;
    checkAvailabilityByEmail(email: string): Promise<{
        available: boolean;
    }>;
    checkAvailabilityByUsername(username: string): Promise<{
        available: boolean;
    }>;
    activate(token: string): Promise<void>;
    resetPasswordRequest(email: string): Promise<ISimpleResponse>;
    changePassword(options: IChangePasswordRequest): Promise<ISimpleResponse>;
    resetPassword(options: IResetPasswordRequest): Promise<ISimpleResponse>;
    editName(newName: IEditNameRequest): Promise<ISimpleResponse>;
}
export {};
