var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Service } from "@crazyfactory/tinka";
import autobind from "autobind-decorator";
var Users = /** @class */ (function (_super) {
    __extends(Users, _super);
    function Users() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Users.prototype.create = function (user) {
        var request = {
            body: JSON.stringify(user),
            method: "POST",
            url: "/users"
        };
        return this.client.process(request);
    };
    Users.prototype.checkAvailabilityByEmail = function (email) {
        var request = {
            url: "/user/availability/email/" + email
        };
        return this.client.process(request);
    };
    Users.prototype.checkAvailabilityByUsername = function (username) {
        var request = {
            url: "/user/availability/username/" + username
        };
        return this.client.process(request);
    };
    Users.prototype.activate = function (token) {
        var request = {
            method: "POST",
            url: "/user/activate/" + token
        };
        return this.client.process(request);
    };
    Users.prototype.resetPasswordRequest = function (email) {
        var request = {
            body: JSON.stringify({ email: email }),
            method: "POST",
            url: "/user/forgot_password"
        };
        return this.client.process(request);
    };
    Users.prototype.changePassword = function (options) {
        var request = {
            body: JSON.stringify(options),
            method: "POST",
            url: "/user/change_password"
        };
        return this.client.process(request);
    };
    Users.prototype.resetPassword = function (options) {
        var request = {
            body: JSON.stringify(options),
            method: "POST",
            url: "/user/reset_password"
        };
        return this.client.process(request);
    };
    Users.prototype.editName = function (newName) {
        var request = {
            body: JSON.stringify(newName),
            method: "PATCH",
            url: "/user/edit_name"
        };
        return this.client.process(request);
    };
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "create", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "checkAvailabilityByEmail", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "checkAvailabilityByUsername", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "activate", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "resetPasswordRequest", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "changePassword", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "resetPassword", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Users.prototype, "editName", null);
    return Users;
}(Service));
export { Users };
