import { Client, MockMiddleware } from "@crazyfactory/tinka";
import { Users } from "./Users";
var mockMw = new MockMiddleware([
    {
        match: function () { return true; },
        resultFactory: function () { return MockMiddleware.resolvingPromise(undefined, 5); }
    }
]);
var client = new Client({ baseUrl: "" });
client.addMiddleware(mockMw);
describe("Users", function () {
    it("should be defined", function () {
        expect(Users).toBeDefined();
    });
    it("should have create function", function () {
        var users = new Users(undefined);
        expect(typeof users.create).toBe("function");
    });
    it("should have availability methods", function () {
        var users = new Users(undefined);
        expect(typeof users.checkAvailabilityByUsername).toBe("function");
        expect(typeof users.checkAvailabilityByEmail).toBe("function");
    });
    it("should return promise", function () {
        var users = new Users(client);
        expect(users.checkAvailabilityByUsername("user") instanceof Promise).toBe(true);
        expect(users.checkAvailabilityByEmail("admin@devcurate.co") instanceof Promise).toBe(true);
        expect(users.create({ username: "", password: "", last_name: "", first_name: "", email: "" }) instanceof Promise).toBe(true);
    });
});
